#include "ti86asm.inc"
#include "Asm86.h"
#include "Rom86.h"

.plugin lite86;                     ;the ultimate compression routine

_ioprompt   =$c324
_asap_ind   =$d623
_getcode    =$4068

Str_A       equ   $ca00
Str_B       equ   $ca00+10
Str_C       equ   $ca00+20
Str_D       equ   $ca00+30
Str_E       equ   $ca00+40
Str_F       equ   $ca00+50
Str_G       equ   $ca00+60
Str_H       equ   $ca00+70
Str_I       equ   $ca00+80
Str_J       equ   $ca00+90
Str_K       equ   $ca00+100
Str_L       equ   $ca00+110
Str_M       equ   $ca00+120
Str_N       equ   $ca00+130
Str_T       equ   $ca00+140
Str_V       equ   $ca00+150
Str_Theta   equ   $ca00+160

.org _asm_exec_ram 

    nop                             ;no operation so...
    jp Start                        ;jump to Start
    .dw 0                           ;type of input
    .dw String0                     ;print string

String0:    .db "The Trigonometry Machine v3.6",0

Start:
    call _clrScrn
    call _runindicoff               ;turn off run indicator
    set trigdeg,(iy+trigflags)      ;turns on degree mode
    call _flushallmenus             ;clears all key codes
    call _clrScrn                   ;clear screen
    call Set_Variables              ;goes to Set_Variables
    call TriangleView               ;goes to Triangle_Answers_2
    jr SIDES_Tri_Change

;========================================================
; PRIMARY MENU ROUTINES - WE STILL NEED THE NUMBERS :-( =
;========================================================

SIDES_Menu_View_Change_1:
    call Text3
SIDES_Tri_Change:
    ld a,3
    call _setXXop2
    ld hl,Str_N
    call Recall
    call _cpop1op2
    jr z,SIDES_Menu_1
    ld hl,String24
    call Text1
    ld hl,String6 
    call Text2
SIDES_Menu_1:
    call EmptyMenu
    ld hl,String4 
    ld bc,256*58+5
    ld (_penCol),bc
    call _vputs
    ld bc,256*58+62
    ld (_penCol),bc
    call _vputs
    ld bc,256*58+87
    ld (_penCol),bc
    call _vputs
    ld bc,256*58+112
    ld (_penCol),bc
    call _vputs
    call MenuRoutine1
SIDES_GetKey_1:
    call _getcode
    cp K_EXIT
    jp z,Exit
    cp K_ALPHA
    call z,CalcOff
    cp K_F1
    jr z,ANGLE_Tri_Change
    cp K_F2
    jr z,SIDES_Menu_View_Change_1
    cp K_F3
    jp z,Input_a
    cp K_F4
    jp z,Input_b
    cp K_F5
    jp z,Input_c
    jr SIDES_GetKey_1

ANGLE_Menu_View_Change_1:
    call Text3
ANGLE_Tri_Change:
    ld a,3
    call _setXXop2
    ld hl,Str_N
    call Recall
    call _cpop1op2
    jr z,ANGLE_Menu_1
    ld hl,String23
    call Text2
    ld hl,String10
    call Text1
ANGLE_Menu_1:
    call EmptyMenu
    ld hl,String9 
    ld bc,256*58+3
    ld (_penCol),bc
    call _vputs
    ld hl,String5 
    call _vputs
    ld hl,String10
    ld bc,256*58+60
    ld (_penCol),bc
    call _vputs
    ld bc,256*58+86
    ld (_penCol),bc
    call _vputs
    ld bc,256*58+110
    ld (_penCol),bc
    call _vputs
    call MenuRoutine1
ANGLE_GetKey_1:
    call _getcode
    cp K_EXIT
    jp z,Exit
    cp K_ALPHA
    call z,CalcOff
    cp K_F1
    jp z,SIDES_Tri_Change
    cp K_F2
    jr z,ANGLE_Menu_View_Change_1
    cp K_F3
    jr z,Input_A
    cp K_F4
    jr z,Input_B
    cp K_F5
    jp z,Input_C
    jr ANGLE_GetKey_1

;======================================================
; NUMBER INPUT'S - LETS GET THOSE STINKIN NUMBERS :-) =
;======================================================

Input_a:
    call _clrScrn
    call _homeup
    ld hl,String13
    call _puts
    ld hl,String22
    call Input
    ld de,Str_D
    jr End_Input_1

Input_b:
    call _clrScrn
    call _homeup
    ld hl,String14
    call _puts
    ld hl,String22
    call Input
    ld de,Str_E
    jr End_Input_1

Input_c:
    call _clrScrn
    call _homeup
    ld hl,String15
    call _puts
    ld hl,String22
    call Input
    ld de,Str_F
End_Input_1:
    call Create
    call Check_For_3
    ld a,c
    cp 2
    jr z,Start_Math
    call Text4
    jp SIDES_Tri_Change

Input_A:
    call _clrScrn
    call _homeup
    ld hl,String16
    call _puts
    ld hl,String22
    call Input
    ld de,Str_A
    jr End_Input_2

Input_B:
    call _clrScrn
    call _homeup
    ld hl,String17
    call _puts
    ld hl,String22
    call Input
    ld de,Str_B
    jr End_Input_2

Input_C:
    call _clrScrn
    call _homeup
    ld hl,String18
    call _puts
    ld hl,String22
    call Input
    ld de,Str_C
End_Input_2:
    call Create
    call Check_For_3
    ld a,c
    cp 2
    jr z,Start_Math
    call Text4
    jp ANGLE_Tri_Change

;==================================
; A WHOLE SHIT LOAD OF MATH STUFF =    <-- 1,285 Lines Of Code
;==================================
;
; NOTE: I didn't bother optimizing this code since Lite 86 II
;       can ultimately do it better than me. Trust me I have tried :-)

Start_Math:
    call _homeup
    call _clrScrn
    ld hl,Str_A
    call Recall
    ld de,Str_G
    call Create
    ld hl,Str_B
    call Recall
    ld de,Str_H
    call Create
    ld hl,Str_C
    call Recall
    ld de,Str_I
    call Create
    ld hl,Str_D
    call Recall
    ld de,Str_J
    call Create
    ld hl,Str_E
    call Recall
    ld de,Str_K
    call Create
    ld hl,Str_F
    call Recall
    ld de,Str_L
    call Create
    xor a
    call _setXXop1
    ld de,Str_M
    call Create
Check_For_At_Least_One_Side_Input:
    ld hl,Str_D
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jr nz,Solve_A_BDE
    ld hl,Str_E
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jr nz,Solve_A_BDE
    ld hl,Str_F
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jr nz,Solve_A_BDE
    jp No_Answer
Solve_A_BDE:                        ;sin-1 ((sin B*D)/E)==>A
    ld hl,Str_A                     ;180-A==>G
    call Recall                     ;H-A==>I
    xor a                           ;J/sin G*sin I==>L
    call _setXXop2
    call _cpop1op2
    jp nz,Solve_A_CDF
    ld hl,Str_B
    call Recall
    rst 08h
    ld hl,Str_D
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_E
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jp z,Solve_A_CDF
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jp z,Solve_A_CDF
    ld hl,Str_B
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_D
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_E
    call Recall
    call _ex_op1_op2
    call _FPDIV
    call _ASIN
    ld de,Str_A
    call Create
    ld a,45
    call _setXXop2
    ld a,4
    call _setXXop1
    rst 28h
    rst 08h
    ld hl,Str_A
    call Recall
    call _ex_op1_op2
    call _FPSUB
    ld de,Str_G
    call Create
    ld hl,Str_H
    call Recall
    rst 08h
    ld hl,Str_A
    call Recall
    call _FPSUB
    ld de,Str_I
    call Create
    ld hl,Str_G
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_J
    call Recall
    call _FPDIV
    call _op1toop6
    ld hl,Str_I
    call Recall
    call _SIN
    call _op6toop2
    rst 28h
    ld de,Str_L
    call Create
    call Math1
Solve_A_CDF:                        ;sin-1 ((sin C*D)/F)==>A
    ld hl,Str_A                     ;180-A==>G
    call Recall                     ;I-A==>H
    xor a                           ;J/sin G*sin H==>K
    call _setXXop2
    call _cpop1op2
    jp nz,Solve_B_AED
    ld hl,Str_C
    call Recall
    rst 08h
    ld hl,Str_D
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_F
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jp z,Solve_B_AED
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jp z,Solve_B_AED
    ld hl,Str_C
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_D
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_F
    call Recall
    call _ex_op1_op2
    call _FPDIV
    call _ASIN
    ld de,Str_A
    call Create
    ld a,45
    call _setXXop2
    ld a,4
    call _setXXop1
    rst 28h
    rst 08h
    ld hl,Str_A
    call Recall
    call _ex_op1_op2
    call _FPSUB
    ld de,Str_G
    call Create
    ld hl,Str_I
    call Recall
    rst 08h
    ld hl,Str_A
    call Recall
    call _FPSUB
    ld de,Str_H
    call Create
    ld hl,Str_G
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_J
    call Recall
    call _FPDIV
    call _op1toop6
    ld hl,Str_H
    call Recall
    call _SIN
    call _op6toop2
    rst 28h
    ld de,Str_K
    call Create
    call Math1
Solve_B_AED:                        ;sin-1 ((sin A*E)/D)==>B
    ld hl,Str_B                     ;180-B==>H
    call Recall                     ;G-B==>I
    xor a                           ;J/sin G*sin I==>L
    call _setXXop2
    call _cpop1op2
    jp nz,Solve_B_CEF
    ld hl,Str_A
    call Recall
    rst 08h
    ld hl,Str_E
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_D
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jp z,Solve_B_CEF
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jp z,Solve_B_CEF
    ld hl,Str_A
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_E
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_D
    call Recall
    call _ex_op1_op2
    call _FPDIV
    call _ASIN
    ld de,Str_B
    call Create
    ld a,45
    call _setXXop2
    ld a,4
    call _setXXop1
    rst 28h
    rst 08h
    ld hl,Str_B
    call Recall
    call _ex_op1_op2
    call _FPSUB
    ld de,Str_H
    call Create
    ld hl,Str_G
    call Recall
    rst 08h
    ld hl,Str_B
    call Recall
    call _FPSUB
    ld de,Str_I
    call Create
    ld hl,Str_G
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_J
    call Recall
    call _FPDIV
    call _op1toop6
    ld hl,Str_I
    call Recall
    call _SIN
    call _op6toop2
    rst 28h
    ld de,Str_L
    call Create
    call Math1
Solve_B_CEF:                        ;sin-1 ((sin C*E)/F)==>B
    ld hl,Str_B                     ;180-B==>H
    call Recall                     ;I-B==>G
    xor a                           ;K/sin H*sin G==>J
    call _setXXop2
    call _cpop1op2
    jp nz,Solve_C_AFD
    ld hl,Str_C
    call Recall
    rst 08h
    ld hl,Str_E
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_F
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jp z,Solve_C_AFD
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jp z,Solve_C_AFD
    ld hl,Str_C
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_E
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_F
    call Recall
    call _ex_op1_op2
    call _FPDIV
    call _ASIN
    ld de,Str_B
    call Create
    ld a,45
    call _setXXop2
    ld a,4
    call _setXXop1
    rst 28h
    rst 08h
    ld hl,Str_B
    call Recall
    call _ex_op1_op2
    call _FPSUB
    ld de,Str_H
    call Create
    ld hl,Str_I
    call Recall
    rst 08h
    ld hl,Str_B
    call Recall
    call _FPSUB
    ld de,Str_G
    call Create
    ld hl,Str_H
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_K
    call Recall
    call _FPDIV
    call _op1toop6
    ld hl,Str_G
    call Recall
    call _SIN
    call _op6toop2
    rst 28h
    ld de,Str_J
    call Create
    call Math1
Solve_C_AFD:                        ;sin-1 ((sin A*F)/D)==>C
    ld hl,Str_C                     ;180-C==>I
    call Recall                     ;G-C==>H
    xor a                           ;J/sin G*sin H==>K
    call _setXXop2
    call _cpop1op2
    jp nz,Solve_C_BFE
    ld hl,Str_A
    call Recall
    rst 08h
    ld hl,Str_F
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_D
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jp z,Solve_C_BFE
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jp z,Solve_C_BFE
    ld hl,Str_A
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_F
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_D
    call Recall
    call _ex_op1_op2
    call _FPDIV
    call _ASIN
    ld de,Str_C
    call Create
    ld a,45
    call _setXXop2
    ld a,4
    call _setXXop1
    rst 28h
    rst 08h
    ld hl,Str_C
    call Recall
    call _ex_op1_op2
    call _FPSUB
    ld de,Str_I
    call Create
    ld hl,Str_G
    call Recall
    rst 08h
    ld hl,Str_C
    call Recall
    call _FPSUB
    ld de,Str_H
    call Create
    ld hl,Str_G
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_J
    call Recall
    call _FPDIV
    call _op1toop6
    ld hl,Str_H
    call Recall
    call _SIN
    call _op6toop2
    rst 28h
    ld de,Str_K
    call Create
    call Math1
Solve_C_BFE:                        ;sin-1 ((sin B*F)/E)==>C
    ld hl,Str_C                     ;180-C==>I
    call Recall                     ;H-C==>G
    xor a                           ;K/sin H*sin G==>J
    call _setXXop2
    call _cpop1op2
    jp nz,Solve_C_BA
    ld hl,Str_B
    call Recall
    rst 08h
    ld hl,Str_F
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_E
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jp z,Solve_C_BA
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jp z,Solve_C_BA 
    ld hl,Str_B
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_F
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_E
    call Recall
    call _ex_op1_op2
    call _FPDIV
    call _ASIN
    ld de,Str_C
    call Create
    ld a,45
    call _setXXop2
    ld a,4
    call _setXXop1
    rst 28h
    rst 08h
    ld hl,Str_C
    call Recall
    call _ex_op1_op2
    call _FPSUB
    ld de,Str_I
    call Create
    ld hl,Str_H
    call Recall
    rst 08h
    ld hl,Str_C
    call Recall
    call _FPSUB
    ld de,Str_G
    call Create
    ld hl,Str_H
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_K
    call Recall
    call _FPDIV
    call _op1toop6
    ld hl,Str_G
    call Recall
    call _SIN
    call _op6toop2
    rst 28h
    ld de,Str_J
    call Create
    call Math1
Solve_C_BA:                         ;180-A-B==>C
    ld hl,Str_C
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jr nz,Solve_B_CA
    ld hl,Str_B
    call Recall
    rst 08h
    ld hl,Str_A
    call Recall
    rst 28h
    xor a
    call _setXXop2
    call _cpop1op2
    jr z,Solve_B_CA
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jr z,Solve_B_CA 
    ld hl,Str_A
    call Recall
    rst 08h
    ld hl,Str_B
    call Recall
    rst 30h
    call _op1toop6
    ld a,45
    call _setXXop2
    ld a,4
    call _setXXop1
    rst 28h
    call _op6toop2
    call _FPSUB
    ld de,Str_C
    call Create
    call Math2
Solve_B_CA:                         ;180-A-C==>B
    ld hl,Str_B
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jr nz,Solve_A_BC
    ld hl,Str_C
    call Recall
    rst 08h
    ld hl,Str_A
    call Recall
    rst 28h
    xor a
    call _setXXop2
    call _cpop1op2
    jr z,Solve_A_BC
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jr z,Solve_A_BC 
    ld hl,Str_A
    call Recall
    rst 08h
    ld hl,Str_C
    call Recall
    rst 30h
    call _op1toop6
    ld a,45
    call _setXXop2
    ld a,4
    call _setXXop1
    rst 28h
    call _op6toop2
    call _FPSUB
    ld de,Str_B
    call Create
    call Math2
Solve_A_BC:                         ;180-B-C==>A
    ld hl,Str_A
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jr nz,Solve_C_FDE
    ld hl,Str_C
    call Recall
    rst 08h
    ld hl,Str_B
    call Recall
    rst 28h
    xor a
    call _setXXop2
    call _cpop1op2
    jr z,Solve_C_FDE
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jr z,Solve_C_FDE
    ld hl,Str_B
    call Recall
    rst 08h
    ld hl,Str_C
    call Recall
    rst 30h
    call _op1toop6
    ld a,45
    call _setXXop2
    ld a,4
    call _setXXop1
    rst 28h
    call _op6toop2
    call _FPSUB
    ld de,Str_A
    call Create
    call Math2
Solve_C_FDE:                        ;cos-1 ((F^2-D^2-E^2)/(-2*D*E))==>C
    ld hl,Str_C
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jp nz,Solve_B_FDE
    ld hl,Str_F
    call Recall
    rst 08h
    ld hl,Str_D
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_E
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jr z,Solve_B_FDE
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jr z,Solve_B_FDE
    ld hl,Str_E
    call Recall
    call _FPSQUARE
    call _op1toop6
    ld hl,Str_D
    call Recall
    call _FPSQUARE
    call _op6toop2
    rst 30h
    call _op1toop6
    ld hl,Str_F
    call Recall
    call _FPSQUARE
    call _op6toop2
    call _FPSUB
    call _op1toop6
    ld hl,Str_E
    call Recall
    rst 08h
    ld hl,Str_D
    call Recall
    rst 28h
    rst 08h
    ld a,2
    call _setXXop1
    call _invop1s
    rst 28h
    rst 08h
    call _op6toop1
    call _FPDIV
    call _ACOS
    ld de,Str_C
    call Create
    call Math2
Solve_B_FDE:                        ;cos-1 ((E^2-D^2-F^2)/(-2*D*F))==>B
    ld hl,Str_B
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jp nz,Solve_A_FDE
    ld hl,Str_F
    call Recall
    rst 08h
    ld hl,Str_D
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_E
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jr z,Solve_A_FDE
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jr z,Solve_A_FDE
    ld hl,Str_F
    call Recall
    call _FPSQUARE
    call _op1toop6
    ld hl,Str_D
    call Recall
    call _FPSQUARE
    call _op6toop2
    rst 30h
    call _op1toop6
    ld hl,Str_E
    call Recall
    call _FPSQUARE
    call _op6toop2
    call _FPSUB
    call _op1toop6
    ld hl,Str_F
    call Recall
    rst 08h
    ld hl,Str_D
    call Recall
    rst 28h
    rst 08h
    ld a,2
    call _setXXop1
    call _invop1s
    rst 28h
    rst 08h
    call _op6toop1
    call _FPDIV
    call _ACOS
    ld de,Str_B
    call Create
    call Math2
Solve_A_FDE:                        ;cos-1 ((D^2-E^2-F^2)/(-2*E*F))==>A
    ld hl,Str_A
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jp nz,Solve_F_DEC
    ld hl,Str_F
    call Recall
    rst 08h
    ld hl,Str_D
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_E
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jr z,Solve_F_DEC
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jr z,Solve_F_DEC
    ld hl,Str_F
    call Recall
    call _FPSQUARE
    call _op1toop6
    ld hl,Str_E
    call Recall
    call _FPSQUARE
    call _op6toop2
    rst 30h
    call _op1toop6
    ld hl,Str_D
    call Recall
    call _FPSQUARE
    call _op6toop2
    call _FPSUB
    call _op1toop6
    ld hl,Str_F
    call Recall
    rst 08h
    ld hl,Str_E
    call Recall
    rst 28h
    rst 08h
    ld a,2
    call _setXXop1
    call _invop1s
    rst 28h
    rst 08h
    call _op6toop1
    call _FPDIV
    call _ACOS
    ld de,Str_A
    call Create
    call Math2
Solve_F_DEC:                        ;Square Root(D^2+E^2-2*D*E*cos C)==>F
    ld hl,Str_F
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jr nz,Solve_D_FEA
    ld hl,Str_D
    call Recall
    rst 08h
    ld hl,Str_E
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_C
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jr z,Solve_D_FEA
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jr z,Solve_D_FEA
    ld hl,Str_D
    call Recall
    call _FPSQUARE
    call _op1toop6
    ld hl,Str_E
    call Recall
    call _FPSQUARE
    call _op6toop2
    rst 30h
    call _op1toop6
    ld hl,Str_C
    call Recall
    call _COS
    rst 08h
    ld hl,Str_E
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_D
    call Recall
    rst 28h
    ld a,2
    call _setXXop2
    rst 28h
    rst 08h
    call _op6toop1
    call _FPSUB
    call _SQROOT
    ld de,Str_F
    call Create
    call Math2
Solve_D_FEA:                        ;Square Root(F^2+E^2-2*F*E*cos A)==>D
    ld hl,Str_D
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jr nz,Solve_E_DFB
    ld hl,Str_F
    call Recall
    rst 08h
    ld hl,Str_E
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_A
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jr z,Solve_E_DFB
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jr z,Solve_E_DFB
    ld hl,Str_F
    call Recall
    call _FPSQUARE
    call _op1toop6
    ld hl,Str_E
    call Recall
    call _FPSQUARE
    call _op6toop2
    rst 30h
    call _op1toop6
    ld hl,Str_A
    call Recall
    call _COS
    rst 08h
    ld hl,Str_E
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_F
    call Recall
    rst 28h
    ld a,2
    call _setXXop2
    rst 28h
    rst 08h
    call _op6toop1
    call _FPSUB
    call _SQROOT
    ld de,Str_D
    call Create
    call Math2
Solve_E_DFB:                        ;Square Root(D^2+F^2-2*D*F*cos B)==>E
    ld hl,Str_E
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jr nz,Solve_D_BEA
    ld hl,Str_D
    call Recall
    rst 08h
    ld hl,Str_F
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_B
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jr z,Solve_D_BEA
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jr z,Solve_D_BEA
    ld hl,Str_D
    call Recall
    call _FPSQUARE
    call _op1toop6
    ld hl,Str_F
    call Recall
    call _FPSQUARE
    call _op6toop2
    rst 30h
    call _op1toop6
    ld hl,Str_B
    call Recall
    call _COS
    rst 08h
    ld hl,Str_F
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_D
    call Recall
    rst 28h
    ld a,2
    call _setXXop2
    rst 28h
    rst 08h
    call _op6toop1
    call _FPSUB
    call _SQROOT
    ld de,Str_E
    call Create
    call Math2
Solve_D_BEA:                        ;E/sin B*sin A==>D
    ld hl,Str_D
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jr nz,Solve_D_FCA
    ld hl,Str_B
    call Recall
    rst 08h
    ld hl,Str_E
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_A
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jr z,Solve_D_FCA
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jr z,Solve_D_FCA
    ld hl,Str_B
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_E
    call Recall
    call _FPDIV
    call _op1toop6
    ld hl,Str_A
    call Recall
    call _SIN
    call _op6toop2
    rst 28h
    ld de,Str_D
    call Create
    call Math2
Solve_D_FCA:                        ;F/sin C*sin A==>D
    ld hl,Str_D
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jr nz,Solve_E_DAB
    ld hl,Str_F
    call Recall
    rst 08h
    ld hl,Str_C
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_A
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jr z,Solve_E_DAB
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jr z,Solve_E_DAB
    ld hl,Str_C
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_F
    call Recall
    call _FPDIV
    call _op1toop6
    ld hl,Str_A
    call Recall
    call _SIN
    call _op6toop2
    rst 28h
    ld de,Str_D
    call Create
    call Math2
Solve_E_DAB:                        ;D/sin A*sin B==>E
    ld hl,Str_E
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jr nz,Solve_E_FCB
    ld hl,Str_D
    call Recall
    rst 08h
    ld hl,Str_A
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_B
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jr z,Solve_E_FCB
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jr z,Solve_E_FCB
    ld hl,Str_A
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_D
    call Recall
    call _FPDIV
    call _op1toop6
    ld hl,Str_B
    call Recall
    call _SIN
    call _op6toop2
    rst 28h
    ld de,Str_E
    call Create
    call Math2
Solve_E_FCB:                        ;F/sin C*sin B==>E
    ld hl,Str_E
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jr nz,Solve_F_DAC
    ld hl,Str_F
    call Recall
    rst 08h
    ld hl,Str_C
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_B
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jr z,Solve_F_DAC
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jr z,Solve_F_DAC
    ld hl,Str_C
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_F
    call Recall
    call _FPDIV
    call _op1toop6
    ld hl,Str_B
    call Recall
    call _SIN
    call _op6toop2
    rst 28h
    ld de,Str_E
    call Create
    call Math2
Solve_F_DAC:                        ;D/sin A*sin C==>F
    ld hl,Str_F
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jr nz,Solve_F_EBC
    ld hl,Str_D
    call Recall
    rst 08h
    ld hl,Str_A
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_C
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jr z,Solve_F_EBC
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jr z,Solve_F_EBC
    ld hl,Str_A
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_D
    call Recall
    call _FPDIV
    call _op1toop6
    ld hl,Str_C
    call Recall
    call _SIN
    call _op6toop2
    rst 28h
    ld de,Str_F
    call Create
    call Math2
Solve_F_EBC:                        ;E/sin B*sin C==>F
    ld hl,Str_F
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jr nz,Theta_Check
    ld hl,Str_E
    call Recall
    rst 08h
    ld hl,Str_B
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_C
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jr z,Theta_Check
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jr z,Theta_Check
    ld hl,Str_B
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_E
    call Recall
    call _FPDIV
    call _op1toop6
    ld hl,Str_C
    call Recall
    call _SIN
    call _op6toop2
    rst 28h
    ld de,Str_F
    call Create
    call Math2
Theta_Check:
    ld hl,Str_Theta
    call Recall
    ld a,3
    call _setXXop2
    call _cpop1op2
    jp nz,Solve_C_BA
    jr More_Than_One_Answer

Area_1:
    ld hl,Str_G
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_L
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_K
    call Recall
    rst 28h
    rst 08h
    call _TIMESPT5
    call _clrScrn
    call _homeup
    ld hl,String21
    call _puts
    ld hl,(256*2)+1
    ld (_curRow),hl
    call DispAnswer3
    call _getkey
    jp Area_Return_1

Area_2:
    ld hl,Str_A
    call Recall
    call _SIN
    rst 08h
    ld hl,Str_F
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_E
    call Recall
    rst 28h
    rst 08h
    call _TIMESPT5
    call _clrScrn
    call _homeup
    ld hl,String21
    call _puts
    ld hl,(256*2)+1
    ld (_curRow),hl
    call DispAnswer3
    call _getkey
    jp Area_Return_2

;======================================================
; SECONDARY MENU ROUTINES - WE'VE GOT THE ANSWERS :-) =
;======================================================

More_Than_One_Answer:
    ld hl,Str_M
    call Recall
    ld a,1
    call _setXXop2
    call _cpop1op2
    jp nz,One_Answer
    ld hl,Str_G
    call Recall
    ld a,0
    call _setXXop2
    call _cpop1op2
    jp z,One_Answer
    call _ckop1pos
    jp nz,One_Answer
    ld hl,Str_H
    call Recall
    ld a,0
    call _setXXop2
    call _cpop1op2
    jp z,One_Answer
    call _ckop1pos
    jp nz,One_Answer
    ld hl,Str_I
    call Recall
    ld a,0
    call _setXXop2
    call _cpop1op2
    jp z,One_Answer
    call _ckop1pos
    jp nz,One_Answer
    ld hl,Str_J
    call Recall
    ld a,0
    call _setXXop2
    call _cpop1op2
    jp z,One_Answer
    call _ckop1pos
    jp nz,One_Answer
    ld hl,Str_K
    call Recall
    ld a,0
    call _setXXop2
    call _cpop1op2
    jp z,One_Answer
    call _ckop1pos
    jp nz,One_Answer
    ld hl,Str_L
    call Recall
    ld a,0
    call _setXXop2
    call _cpop1op2
    jp z,One_Answer
    call _ckop1pos
    jp nz,One_Answer

Area_Return_1:
    call Text6
    jr Answers_Menu_1
Answers_Menu_View_Change_1:
    call Text5
Answers_Menu_1:
    call EmptyMenu
    ld hl,String19
    ld bc,256*58+6
    ld (_penCol),bc
    call _vputs
    call MenuRoutine1
Answers_GetKey_1:
    call _getcode
    cp K_EXIT
    jp z,Exit
    cp K_ALPHA
    call z,CalcOff
    cp K_F1
    jr z,One_Answer      
    cp K_F2
    jr z,Answers_Menu_View_Change_1
    cp K_F3
    jp z,Area_1
    jr Answers_GetKey_1

One_Answer:
    ld hl,Str_A
    call Recall
    rst 08h
    ld hl,Str_B
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_C
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_D
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_E
    call Recall
    rst 28h
    rst 08h
    ld hl,Str_F
    call Recall
    rst 28h
    rst 08h
    xor a
    call _setXXop2
    call _cpop1op2
    jr z,No_Answer
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jr z,No_Answer

Area_Return_2:
    call Text8
    jr Answers_Menu_2
Answers_Menu_View_Change_2:
    call Text7
Answers_Menu_2:
    call EmptyMenu
    ld hl,String20
    ld bc,256*58+7
    ld (_penCol),bc
    call _vputs
    ld bc,256*58+107
    ld (_penCol),bc
    call _vputs
    call MenuRoutine1
Answers_GetKey_2:
    call _getcode
    cp K_EXIT
    jp z,Exit
    cp K_ALPHA
    call z,CalcOff
    cp K_F1
    jp z,Start           
    cp K_F2
    jr z,Answers_Menu_View_Change_2
    cp K_F3
    jp z,Area_2
    cp K_F5
    jp z,Exit
    jr Answers_GetKey_2

No_Answer:
    call _clrScrn
    ld hl,(256*6)+3
    ld (_curRow),hl
    ld hl,String25
    call _puts
    call _getkey
    jp Exit

;===========================
; CHECK FOR _____ ROUTINES =
;===========================

Check_For_3:
    xor a
    call _setXXop1
    ld de,Str_T
    call Create
    ld hl,Str_A
    call Check_For_Input
    ld hl,Str_B
    call Check_For_Input
    ld hl,Str_C
    call Check_For_Input
    ld hl,Str_D
    call Check_For_Input
    ld hl,Str_E
    call Check_For_Input
    ld hl,Str_F
    call Check_For_Input
    ld hl,Str_T
    call Recall
    ld a,3
    call _setXXop2
    call _cpop1op2
    jr nz,Not_3_Yet
    ld c,2
    ret
Not_3_Yet:
    ld c,3
    ret

Check_For_Input:
    call Recall
    xor a
    call _setXXop2
    call _cpop1op2
    jr z,Number_Not_Input
    call _ex_op1_op2
    call _FPSUB
    call _ckop1pos
    jr z,Number_Not_Input
    ld a,1
    call _setXXop2
    ld hl,Str_T
    call Recall
    rst 30h
    ld de,Str_T
    call Create
Number_Not_Input:
    ret

;===============================================
; SCREEN VIEW OPTIONS - DISPLAYS SELECTED VIEW =
;===============================================

TriangleView:
    ld b,63
    ld c,49
    ld d,13
    ld e,15
    ld h,1
    call _ILine
    ld d,113
    call _ILine
    ld b,13
    ld c,15
    call _ILine
    ld hl,String1 
    ld bc,256*1+1
    ld (_penCol),bc
    call _vputs
    ld bc,256*7+1
    ld (_penCol),bc
    call _vputs
    ld bc,256*13+1
    ld (_penCol),bc
    call _vputs
    ld a,2
    call _setXXop1
    ld de,Str_V
    call Create
    ld de,Str_N
    call Create
    ret

Triangle_Answers_1:
    call TriangleView
    ld hl,Str_G
    call Recall
    ld bc,256*41+25
    ld (_penCol),bc
    call DispAnswer2
    ld hl,Str_H
    call Recall
    ld bc,256*41+94
    ld (_penCol),bc
    call DispAnswer2
    ld hl,Str_I
    call Recall
    ld bc,256*18+59
    ld (_penCol),bc
    call DispAnswer2
    ld hl,Str_J
    call Recall
    ld bc,256*24+88
    ld (_penCol),bc
    call DispAnswer2
    ld hl,Str_K
    call Recall
    ld bc,256*24+33
    ld (_penCol),bc
    call DispAnswer2
    ld hl,Str_L
    call Recall
    ld bc,256*49+60
    ld (_penCol),bc
    call DispAnswer2
    ret

Triangle_Answers_2:
    call TriangleView
    ld hl,Str_A
    call Recall
    ld bc,256*41+25
    ld (_penCol),bc
    call DispAnswer2
    ld hl,Str_B
    call Recall
    ld bc,256*41+94
    ld (_penCol),bc
    call DispAnswer2
    ld hl,Str_C
    call Recall
    ld bc,256*18+59
    ld (_penCol),bc
    call DispAnswer2
    ld hl,Str_D
    call Recall
    ld bc,256*24+88
    ld (_penCol),bc
    call DispAnswer2
    ld hl,Str_E
    call Recall
    ld bc,256*24+33
    ld (_penCol),bc
    call DispAnswer2
    ld hl,Str_F
    call Recall
    ld bc,256*49+60
    ld (_penCol),bc
    call DispAnswer2
    ret

NumberView1:
    call _homeup
    ld hl,String13
    call _puts
    ld hl,Str_D
    call Recall
    call DispAnswer1
    call _newline
    ld hl,String14
    call _puts
    ld hl,Str_E
    call Recall
    call DispAnswer1
    call _newline
    ld hl,String15
    call _puts
    ld hl,Str_F
    call Recall
    call DispAnswer1
    call _newline
    ld hl,String16
    call _puts
    ld hl,Str_A
    call Recall
    call DispAnswer1
    call _newline
    ld hl,String17
    call _puts
    ld hl,Str_B
    call Recall
    call DispAnswer1
    call _newline
    ld hl,String18
    call _puts
    ld hl,Str_C
    call Recall
    call DispAnswer1
    call _newline
    ld a,3
    call _setXXop1
    ld de,Str_V
    call Create
    ld a,3
    call _setXXop1
    ld de,Str_N
    call Create
    ret

NumberView2:
    call _homeup
    ld hl,String13
    call _puts
    ld hl,Str_J
    call Recall
    call DispAnswer1
    call _newline
    ld hl,String14
    call _puts
    ld hl,Str_K
    call Recall
    call DispAnswer1
    call _newline
    ld hl,String15
    call _puts
    ld hl,Str_L
    call Recall
    call DispAnswer1
    call _newline
    ld hl,String16
    call _puts
    ld hl,Str_G
    call Recall
    call DispAnswer1
    call _newline
    ld hl,String17
    call _puts
    ld hl,Str_H
    call Recall
    call DispAnswer1
    call _newline
    ld hl,String18
    call _puts
    ld hl,Str_I
    call Recall
    call DispAnswer1
    call _newline
    ld a,3
    call _setXXop1
    ld de,Str_V
    call Create
    ret

;================================
; SET IT - MAKE ALL VARIABLES 0 =
;================================

Set_Variables:
    xor a
    call _setXXop1
    ld de,Str_A
    call Create
    ld de,Str_B
    call Create
    ld de,Str_C
    call Create
    ld de,Str_D
    call Create
    ld de,Str_E
    call Create
    ld de,Str_F
    call Create
    ld de,Str_G
    call Create
    ld de,Str_H
    call Create
    ld de,Str_I
    call Create
    ld de,Str_J
    call Create
    ld de,Str_K
    call Create
    ld de,Str_L
    call Create
    ld de,Str_M
    call Create
    ld de,Str_N
    call Create
    ld de,Str_T
    call Create
    ld de,Str_V
    call Create
    ld de,Str_Theta
    call Create
    ret

;=========================
; MISCELLANEOUS ROUTINES =
;=========================

Create:                     ;save num from OP1
    ld hl,_OP1              ;move 10 bytes from op1
    call _mov10b
    ret

Recall:                     ;restore num to OP1
    ld de,_OP1              ;number to op1
    call _mov10b
    ret

Math1:
    ld a,1
    call _setXXop1
    call _op1toop3
    ld de,Str_M
    call Create
Math2:
    ld hl,Str_Theta
    call Recall
    call _PLUS1
    call _op1toop3
    ld de,Str_Theta
    call Create
    ret

Text1:
    ld bc,256*41+25
    ld (_penCol),bc
    call _vputs
    ld bc,256*41+94
    ld (_penCol),bc
    call _vputs
    ld bc,256*18+59
    ld (_penCol),bc
    call _vputs
    ret

Text2:
    ld bc,256*24+88
    ld (_penCol),bc
    call _vputs
    ld bc,256*24+33
    ld (_penCol),bc
    call _vputs
    ld bc,256*49+60
    ld (_penCol),bc
    call _vputs
    ret

Text3:
    call _clrScrn
    ld a,2
SubText3:
    call _setXXop2
    ld hl,Str_V
    call Recall
    call _cpop1op2
    jr z,Display_Number_View_1
    jr nz,Display_Triangle_View_1

Text4:
    call _clrScrn
    ld a,3
    jr SubText3

Display_Number_View_1:
    call z,NumberView1              ;sets a to 3
    jr Done1
Display_Triangle_View_1:
    call nz,TriangleView            ;sets a to 2
Done1:
    ret

Text5:
    call _clrScrn
    ld a,2
SubText5:
    call _setXXop2
    ld hl,Str_V
    call Recall
    call _cpop1op2
    jr z,Display_Number_View_2
    jr nz,Display_Triangle_View_2

Text6:
    call _clrScrn
    ld a,3
    jr SubText5

Display_Number_View_2:
    call z,NumberView2              ;sets a to 3
    jr Done2
Display_Triangle_View_2:
    call nz,Triangle_Answers_1      ;sets a to 2
Done2:
    ret

Text7:
    call _clrScrn
    ld a,2
SubText7:
    call _setXXop2
    ld hl,Str_V
    call Recall
    call _cpop1op2
    jr z,Display_Number_View_3
    jr nz,Display_Triangle_View_3

Text8:
    call _clrScrn
    ld a,3
    jr SubText7

Display_Number_View_3:
    call z,NumberView1              ;sets a to 3
    jr Done3
Display_Triangle_View_3:
    call nz,Triangle_Answers_2      ;sets a to 2
Done3:
    ret

DispAnswer1:
    ld d,4
    call _ROUND
DispAnswer3:
    ld a,48                         ;loads a with 48
    call _formReal                  ;forms answer to real #
    ld hl,_OP3                      ;loads answer into hl
    call _puts                      ;prints answer
    call _runindicoff               ;turn off run indicator
    ret

DispAnswer2:
    ld d,4
    call _ROUND
    ld a,48                         ;loads a with 48
    call _formReal                  ;forms answer to real #
    ld hl,_OP3                      ;loads answer into hl
    call _vputs                     ;prints answer
    call _runindicoff               ;turn off run indicator
    ret

Input:
    ld de,_ioprompt                 ;$c324 - string storage for display when prompte
    call _mov10b                    ;$427b - move 10 bytes from hl to de
    ld a,$0d                        ;type of input
                                    ;$0d - # value
                                    ;$0c - string
    ld (_asap_ind),a                ;$d623 - tell ti86 what kind to be inputted
    jp _exec_pg3                    ;$5714 - ti86 os input
                                    ;the number inputted is always stored to OP1
    ret                             ;return to call

CalcOff:
    ld a,1
    out (3),a
    halt
    ld a,11
    out (3),a        
    res onInterrupt,(iy+onflags)
    ret

Exit:
    call Set_Variables              ;goes to Set_Variables
    res trigdeg,(iy+trigflags)      ;change back to radian mode
    call _clrScrn                   ;clears the screen
    call _homeup                    ;moves cursor to upper left
    ret

;=================================
; AND OF COURSE ... THE TEXT :-) =
;=================================

#include "Menu86.asm";  <-- routine that draws the 86 style menus

String1:    .db "The Trigonometry Machine",0
String2:    .db "by Kevin Selkowitz",0
String3:    .db "v3.4",0
String4:    .db "SIDES  "
String5:    .db "      view",0
String6:    .db "a",0
String7:    .db "b",0
String8:    .db "c",0
String9:    .db "ANGLE",0
String10:   .db 19,"A",0
String11:   .db 19,"B",0
String12:   .db 19,"C",0
String13:   .db "Side a=",0
String14:   .db "Side b=",0
String15:   .db "Side c=",0
String16:   .db "Angle A=",0
String17:   .db "Angle B=",0
String18:   .db "Angle C=",0
String19:   .db "next          view         area",0
String20:   .db "new          view         area",0
            .db "quit",0
String21:   .db "Area",0
String22:   .db "?",0
String23:   .db "   ",0
            .db "   ",0
            .db "   ",0
String24:   .db "       ",0
            .db "       ",0
            .db "       ",0
String25:   .db "No answer",0

.end
END